%% function getimage(variable)
%% 
%% Reads an image and opens it using an ImageJ macro
%% Creates a file named 'macroIJ.txt'
%% Creates also a file named 'tmpname.txt'
%% 
%% TODO: fix the file names by using OCTAVE comamnds,
%% such as 'octave_tmp_file_name' or 'tmp_nam'
%%
function getimage(variable)

varname=inputname(1);

%system('rm tmpname.txt');

if (size(variable,3) == 3)
  getimage24bpp(variable);
elseif ((size(variable,3) == 1) && (isfloat(variable) == 0))
  getimage8bpp(variable);
elseif ((size(variable,3) == 1) && (isfloat(variable) == 1))

macroname='macroIJ.txt';

filename = sprintf('tmpname.txt');
fullfilename = sprintf('/Users/florent/octave/tmpname.txt');
%save('-ascii', fullfilename, varname);

[FileImg,msg] = fopen (fullfilename,'w+');
for i=1:size(variable,1)
  for j=1:size(variable,2)
    fprintf(FileImg,'%f ',variable(i,j));
  end
  fprintf(FileImg,'\n');
end
fclose(FileImg);


directory = '/Users/florent/octave';

fullmacroname = sprintf('%s/%s',directory,macroname);
[File,msg] = fopen (fullmacroname,'w');

fprintf(File,'// OpenTextImages\n');
fprintf(File,'//\n');
fprintf(File,'// This macro opens a sequence of text images \n');

fprintf(File,'dir = "%s/";\n',directory);
fprintf(File,'list = "%s";\n',filename);

fprintf(File,'setBatchMode(true);\n');
fprintf(File,'run("Text Image... ", "open="+dir+list);\n');
fprintf(File,'run("Copy");\n');
fprintf(File,'width = getWidth;\n');
fprintf(File,'height = getHeight;\n');
fprintf(File,'close();\n');
fprintf(File,'newImage(dir, "32-bit Black", width, height, 1);\n');
fprintf(File,'id = getImageID;\n');
fprintf(File,'run("Paste");\n');
fprintf(File,'setSlice(1);\n');
fprintf(File,'resetMinAndMax;\n');
fprintf(File,'run("Select None");\n');
fprintf(File,'setBatchMode(false);\n');

fclose(File);

%%cmd=['java -cp /Applications/ImageJ/ij.jar ij.ImageJ ' fullmacroname, ' &'];
%%cmd=['java -cp /Applications/ImageJ/ImageJ.app/Contents/Resources/Java/ij.jar ij.ImageJ ' fullmacroname, ' &'];
cmd=['java -jar /Applications/Images/ImageJ/ImageJ.app/Contents/Resources/Java/ij.jar ' fullmacroname, ' &'];

system(cmd);

%system('rm tmpname.txt');

%system('java -cp /Applications/Images/ImageJ/ImageJ.app/Contents/Resources/Java/ij.jar ij.ImageJ macroIJ.txt &');

else
disp('what image format is this ?');
disp('it is neither 24bpp nor 8bpp, and nor text image');
disp('');

end

end
