%% function getimage8bpp(variable)
%% 
%% Reads a 8bpp BMP image and opens it using an ImageJ macro
%% Creates a file named 'macroIJ8bpp.txt'
%% Creates also a file named 'tmpname.bmp'
%% 
%% TODO: fix the file names by using OCTAVE comamnds,
%% such as 'octave_tmp_file_name' or 'tmp_nam'
%%
function getimage8bpp(variable)

varname=inputname(1);

warning off;

%system('rm tmpname.txt');
if (size(variable,3) != 1)
  error('image is not 8bpp\n');
end

%disp('WARNING: function getimage8bpp has a 1 gray level bias');
%disp('         All pixel values will be increased by 1 in ImageJ');

macroname='macroIJ8bpp.txt';
imagepath=sprintf('/Users/florent/octave/');
imagename=[imagepath 'tmpname.pgm'];
pgmWrite((variable-1),imagename);
%bmpwrite(uint8(variable), imagename);

fullmacroname = [imagepath macroname];

[File,msg] = fopen (fullmacroname,'w');

fprintf(File,'// OpenBMPImages\n');
fprintf(File,'//\n');
fprintf(File,'// This macro opens a 8bpp BMP image \n');

fprintf(File,'img = "%s";\n',imagename);
fprintf(File,'open(img)\n');

fclose(File);

cmd=['java -jar /Applications/Images/ImageJ/ImageJ.app/Contents/Resources/Java/ij.jar ' fullmacroname, ' &'];

system(cmd);

end
