%%
%% getplot2('macroname',NbCurves, 'xlabel', 'ylabel', x, y1, 'label1', 'L', y2, 'label2', 'S', ..., 'GraphTitle', 'pdf_name');
%%
%% WARNING: only works on a Mac ! (uses a Mac app : http://plot.micw.eu/)
%%
%% Loads the file macroname.macro and plot with the legends, labels and title specified in this macro
%%
%% INPUTS:
%% - arg1 (STRING) : name of the "Plot" macro provided by "setplotconfig" (will be used by the Plot app: http://plot.micw.eu/).
%% - arg2 (UINT8)  : number of "y" curves to plot.
%% - arg3 (STRING) : x-axis label.
%% - arg4 (STRING) : y-axis label. 
%% - arg5 (VECTOR) : x-data.
%% - arg6 (VECTOR) : y-data.
%% - arg7 (VECTOR) : y-label.
%% - arg8 (VECTOR) : 'L' (line) or 'S' (symbol) or 'B' (bars).
%% - arg9 (VECTOR) : y2-data.
%% - ...
%% - argN-1 (STRING) : A title for the plot.
%% - argN (STRING) : A PDF filename to save the plot.
%%
%% OUTPUTS:
%% - Displays a plot (using the "Plot" application -http://plot.micw.eu/-) and 
%%   saves teh plot as a 'pdf' file if a pdf name was provided in the last argument
%%   getplot will save a data file made of [x, y1, y2, ..., yn] in a temporary filename: (octave_tmp_file_name) and
%%   it will run the cmd line : Plot -i data_file.txt -m arg1.macro -h &
%%
%% To install the Plot app (in the /Applications folder):
%%   export http_proxy=http://cache.polytech.univ-nantes.prive:3128
%%   wget -c http://plot.micw.eu/uploads/Main/Plot0.997.zip
%%   unzip Plot0.997.zip
%%   mv  Plot0.997/Plot.app /Applications/
%%   rm -rf ./Plot0.997
%%   rm Plot0.997.zip 
%%
%%
%% Copyright (C) 2010, Univ. of Nantes, Florent Autrusseau <Florent.Autrusseau@univ-nantes.fr>

function getplot2(varargin)


## getplot2('fitmacro2',3, 'xlabel', 'ylabel', x, y1, 'label1', 'L', y2, 'label2', 'S', y3, 'lab3', 'L', 'Graph Title', 'pdf_name');


macroname = varargin{1}; %'mymacro.macro';
NbY = varargin{2};
oct_xlabel = varargin{3};
oct_ylabel = varargin{4};
x = varargin{5};

%size(varargin{6})
%size(varargin{9})

%varargin{2}
%
%varargin{6} = varargin{6}';
%varargin{9} = varargin{9}';
%x=x';


k=1;
for j=6:3:4+NbY*3-1
  y(k,:) = varargin{j};
  k++;
end

k=1;
for j=7:3:4+NbY*3
  ylegend{k} = varargin{j};
  oct_ylegend{k} = sprintf('"%s"', ylegend{k});
  k++;
end

k=1;
for j=8:3:4+NbY*3+2
  LineStyle{k} = varargin{j};
  oct_LineStyle{k} = sprintf('%s', LineStyle{k});
  k++;
end

graphtitle = varargin{4+NbY*3+2};
if (nargin == (4+NbY*3+3))
	saved_pdf_name = varargin{4+NbY*3+3};
end

if (size(x,1) != size(y(1,:),2))	x=x'; end

if (NbY == 1)
	setplotconfig2(macroname,NbY, oct_xlabel, oct_ylabel, x, y(1,:), oct_ylegend{1}, oct_LineStyle{1}, graphtitle, saved_pdf_name);
elseif (NbY == 2)
	setplotconfig2(macroname,NbY, oct_xlabel, oct_ylabel, x, y(1,:), oct_ylegend{1}, oct_LineStyle{1}, y(2,:), oct_ylegend{2}, oct_LineStyle{2}, graphtitle, saved_pdf_name);
elseif (NbY == 3)
	setplotconfig2(macroname,NbY, oct_xlabel, oct_ylabel, x, y(1,:), oct_ylegend{1}, oct_LineStyle{1}, y(2,:), oct_ylegend{2}, oct_LineStyle{2}, y(3,:), oct_ylegend{3}, oct_LineStyle{3}, graphtitle, saved_pdf_name);
elseif (NbY == 4)
	setplotconfig2(macroname,NbY, oct_xlabel, oct_ylabel, x, y(1,:), oct_ylegend{1}, oct_LineStyle{1}, y(2,:), oct_ylegend{2}, oct_LineStyle{2}, y(3,:), oct_ylegend{3}, oct_LineStyle{3}, y(4,:), oct_ylegend{4}, oct_LineStyle{4}, graphtitle, saved_pdf_name);
elseif (NbY == 5)
	setplotconfig2(macroname,NbY, oct_xlabel, oct_ylabel, x, y(1,:), oct_ylegend{1}, oct_LineStyle{1}, y(2,:), oct_ylegend{2}, oct_LineStyle{2}, y(3,:), oct_ylegend{3}, oct_LineStyle{3}, y(4,:), oct_ylegend{4}, oct_LineStyle{4}, y(5,:), oct_ylegend{5}, oct_LineStyle{5}, graphtitle, saved_pdf_name);
elseif (NbY == 6)
	setplotconfig2(macroname,NbY, oct_xlabel, oct_ylabel, x, y(1,:), oct_ylegend{1}, oct_LineStyle{1}, y(2,:), oct_ylegend{2}, oct_LineStyle{2}, y(3,:), oct_ylegend{3}, oct_LineStyle{3}, y(4,:), oct_ylegend{4}, oct_LineStyle{4}, y(5,:), oct_ylegend{5}, oct_LineStyle{5}, y(6,:), oct_ylegend{6}, oct_LineStyle{6}, graphtitle, saved_pdf_name);
end

x=x';
if (NbY == 1)
  Bunch = [double(x'), double(y(1,:)')];
elseif (NbY == 2)
  Bunch = [double(x'), y(1,:)', double(y(2,:)')];
elseif (NbY == 3)
  Bunch = [double(x'), y(1,:)', double(y(2,:)'), double(y(3,:)')];
elseif (NbY == 4)
  Bunch = [double(x'), y(1,:)', double(y(2,:)'), double(y(3,:)'), double(y(4,:)')];
elseif (NbY == 5)
  Bunch = [double(x'), y(1,:)', double(y(2,:)'), double(y(3,:)'), double(y(4,:)'), double(y(5,:)')];
elseif (NbY == 6)
  Bunch = [double(x'), y(1,:)', double(y(2,:)'), double(y(3,:)'), double(y(4,:)'), double(y(5,:)'), double(y(6,:)')];
end

fullmacroname = sprintf('%s.macro',macroname);
if (exist('OCTAVE_VERSION'))
  dataname = octave_tmp_file_name;
  save('-text', dataname, 'Bunch');
  cmd= sprintf('/Applications/Plot.app/Contents/MacOS/Plot -i %s -m %s -h &',dataname, fullmacroname);
else
  dataname = 'tmp.dat';
  save('-ASCII', '-DOUBLE', dataname, 'Bunch');
  cmd= sprintf('/Applications/Plot.app/Contents/MacOS/Plot -i %s -m %s -h &','tmp.dat', fullmacroname);
end
system(cmd);

end